VERSION 5.00
Object = "{3B7C8863-D78F-101B-B9B5-04021C009402}#1.2#0"; "RICHTX32.OCX"
Begin VB.Form frmMain 
   BorderStyle     =   1  'Fest Einfach
   Caption         =   "Fritz Demo"
   ClientHeight    =   4800
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   8925
   Icon            =   "frmMain.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   ScaleHeight     =   4800
   ScaleWidth      =   8925
   StartUpPosition =   2  'Bildschirmmitte
   Begin VB.CommandButton cmdCancel 
      Cancel          =   -1  'True
      Caption         =   "Abbrechen"
      Enabled         =   0   'False
      Height          =   500
      Left            =   6840
      TabIndex        =   2
      Top             =   4080
      Width           =   2000
   End
   Begin VB.CommandButton cmdStart 
      Caption         =   "Start"
      Default         =   -1  'True
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   500
      Left            =   4560
      Style           =   1  'Grafisch
      TabIndex        =   1
      Top             =   4080
      Width           =   2000
   End
   Begin RichTextLib.RichTextBox redLog 
      Height          =   3615
      Left            =   240
      TabIndex        =   0
      Top             =   240
      Width           =   8535
      _ExtentX        =   15055
      _ExtentY        =   6376
      _Version        =   393217
      BackColor       =   -2147483633
      ReadOnly        =   -1  'True
      ScrollBars      =   3
      DisableNoScroll =   -1  'True
      TextRTF         =   $"frmMain.frx":030A
   End
   Begin VB.Label lblTime 
      Height          =   495
      Left            =   240
      TabIndex        =   3
      Top             =   3960
      Width           =   2535
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
''----------------------------------------------------------------------
''  Demoprogramm zur COM-Bibliothek "FritzDataControlLib"
''
''  Autor:  Christian "NineBerry" Schwarz
''  E-Mail: FritzDataControlLib@NineBerry.de
''  Web:    http://www.NineBerry.de
''
''  Dieses Demoprogramm demonstriert die Verwendung der COM-Bibliothek
''  FritzDataControlLib zur Fernsteuerung des Programms Fritz!data
''  von AVM.
''
''  Das Programm verbindet sich mit dem AVM Data Call Center und
''  ldt von dort die Datei "FRISCR32.txt" aus dem Verzeichnis
''  "TOOLS\FDATASCR" ins Verzeichnis "C:\" des aktuellen Computers.
''  (Anwendung muss dort Schreibrechte haben)
''  Hinweis: Die Datei hat eine Gre von 800 kb. Das Laden dauert
''  etwa 2 Minuten.
''
''  History:
''    2001-09-06  Erste Version aufbauend auf Delphi - Testprogramm fr
''                Delphi-Klasse TFritzDataControl (Grtenteils Copy'n'Paste)
''    2001-09-08  Verwendung von WaitMessage zur Reduktion der
''                Prozessorauslastung
''
''  Die Bibliothek FritzDataControlLib ist Freeware. Sie darf kostenlos und ohne
''  Einschrnkungen in (auch kommerziellen) Softwareprodukten verwendet
''  werden.
''  Nichtsdestotrotz behlt der Autor (Christian "NineBerry" Schwarz) alle
''  Rechte.
''
''  Die Weitergabe dieser Bibliothek ist ohne Einschrnkungen gestattet,
''  solange fr die Funktionalitt der Bibliothek selbst keine Bezahlung
''  verlangt wird
''
''  Falls du diese Bibliothek zur Erstellung von Anwendungen verwendest,
''  wrde ich mich sehr freuen ber:
''    x Namentliche Nennung in der Dokumentation deiner Anwendung.
''    x Eine nette E-Mail oder Postkarte mit Informationen ber dich
''
''----------------------------------------------------------------------

Private Declare Function WaitMessage Lib "user32" () As Long

Const PhoneNumber = "030 39984300"  ' AVM Data Call Center (Berlin)
Const TargetDir = "TOOLS\FDATASCR"  ' Verzeichnis im AVM DCC
Const TargetFile = "FRISCR32.EXE"   ' Dateiname im AVM DCC


Dim Control As FritzDataControlDocument
Dim Aborted As Boolean
Dim StartTime As Date

''----------------------------------------------------------------------
''  Text mit genau Size Zeichen zurckgeben, dabei evt. rechts
''  mit leerzeichen auffllen
''----------------------------------------------------------------------
Function PadLeft(Text As String, Size As Integer) As String

  PadLeft = Mid(Text, 1, Size)
  
  For i = Len(PadLeft) To Size - 1
    PadLeft = PadLeft & " "
  Next i
End Function

''----------------------------------------------------------------------
''  Text mit genau Size Zeichen zurckgeben, dabei evt. links
''  mit leerzeichen auffllen
''----------------------------------------------------------------------
Function PadRight(Text As String, Size As Integer) As String
  PadRight = Mid(Text, 1, Size)
  For i = Len(PadRight) To Size - 1
    PadRight = " " & PadRight
  Next i
End Function

''----------------------------------------------------------------------
''  Cursor ans Ende des Logs setzen, so dass neuer Text dort
''  eingefgt wird
''----------------------------------------------------------------------
Sub PrepareLog()
  ' Cursor an letzte Position
  redLog.SelStart = Len(redLog.Text)
  redLog.SelLength = 0
End Sub

''----------------------------------------------------------------------
''  Log Scrollen
''----------------------------------------------------------------------
Sub LogScrollInView()
  ' redLog.Perform(EM_ScrollCaret, 0, 0);
  ' Nicht notwendig, pasiert in VB automatisch
End Sub

''----------------------------------------------------------------------
''  Leere Zeile im Log einfgen
''----------------------------------------------------------------------
Sub AddLogNewLine()
  PrepareLog
  redLog.SelText = vbNewLine
  LogScrollInView
End Sub

''----------------------------------------------------------------------
''  Status im Log ausgeben
''----------------------------------------------------------------------
Sub AddLogStatus(S As String)

  PrepareLog

  redLog.SelBold = False
  redLog.SelText = ">  " & S & vbNewLine

  LogScrollInView
End Sub

''----------------------------------------------------------------------
''  Fehler im Log ausgeben
''----------------------------------------------------------------------
Sub AddLogError(S As String)

  PrepareLog

  redLog.SelBold = True
  redLog.SelText = "!! " & S & vbNewLine

  LogScrollInView
End Sub

''----------------------------------------------------------------------
''  Anfang einer Verzeichnisliste
''----------------------------------------------------------------------
Sub AddLogStartDirListing()
  PrepareLog

  redLog.SelFontName = "courier"
  AddLogNewLine
  redLog.SelText = "------------------------------------------------------------" & vbNewLine

  LogScrollInView
End Sub
  
''----------------------------------------------------------------------
''  Ende einer Verzeichnisliste
''----------------------------------------------------------------------
Sub AddLogEndDirListing()
  PrepareLog

  redLog.SelText = "------------------------------------------------------------" & vbNewLine
  AddLogNewLine
  redLog.SelFontName = "MS Sans Serif"

  LogScrollInView
End Sub

''----------------------------------------------------------------------
''  Verzeichniseinntrag im Log anzeigen
''----------------------------------------------------------------------
Sub AddLogDirListingItem(Item As FritzDataFileInfo)
  
  Dim S As String
  
  PrepareLog

  S = PadLeft(Item.FileName, 28)

  If Item.Typ = fdftDirectory Then
    S = S & " " & PadRight("<DIR>", 10)
  Else
    S = S & " " & PadRight(CStr(Item.Size), 10)
  End If

  S = S & " " & PadLeft(CStr(Item.LastChange), 20)

  redLog.SelText = S & vbNewLine

  LogScrollInView
End Sub

''----------------------------------------------------------------------
''  Wartet, bis eine asynchrone Aktion beendet ist
''  Reagiert auf Abbruchsanforderung
''----------------------------------------------------------------------
Sub RaiseAbort()
  Err.Raise vbError + 2000, Description:="BenutzerAbbruch"
End Sub


''----------------------------------------------------------------------
''  Wartet, bis eine asynchrone Aktion beendet ist
''  Reagiert auf Abbruchsanforderung
''----------------------------------------------------------------------
Sub WaitUntilReady()
  Dim ConnTime As Date

  Do
    ConnTime = Time - StartTime
    lblTime.Caption = CStr(ConnTime)

    WaitMessage
    DoEvents
    
    If Aborted Then
      
      AddLogError "Abbruch"
      Control.Abort
      
      Do
        WaitMessage
        DoEvents
      Loop While Control.Busy
      
      RaiseAbort
    End If
  Loop While Control.Busy
End Sub

''----------------------------------------------------------------------
''  Gibt Verzeichnislistung aus
''----------------------------------------------------------------------
Sub PrintDirectoryOutput()
  
  Dim FileInfo As FritzDataFileInfo
  
  AddLogStartDirListing
  
  While Control.GetNextDirItem(FileInfo) <> FDFT_EOL
    AddLogDirListingItem FileInfo
  Wend
  
  AddLogEndDirListing
End Sub

''----------------------------------------------------------------------
''  berprft, ob bei letzter Aktion ein Fehler aufgetreten ist
''  Falls ja, wird der Fehlertext angezeigt und eine stille Exception
''  ausgelst, um weitere Aktionen zu unterbinden
''----------------------------------------------------------------------
Sub CheckForErrors()
  If Control.ErrorOccured Then
    If Control.ErrorMessage = EmptyStr Then
      AddLogError "Unbekannter Fehler aufgetreten."
    Else
      AddLogError Control.ErrorMessage
    End If
    
    RaiseAbort
  End If
End Sub


''----------------------------------------------------------------------
''  Fhrt die eigentlichen Aktionen nacheinander aus.
''----------------------------------------------------------------------
Sub Action()
  Dim Info As String
  Dim BInfo As Boolean

  StartTime = Time

  Set Control = New FritzDataControlDocument

  ' Fritz!data darf noch nicht laufen
  If Control.FritzDataAlreadyRuns Then
    MsgBox "Fritz!data luft schon."
    RaiseAbort
  End If

  Aborted = False

  On Error GoTo except
  
    Control.FritzDataConnect
    
    GoTo exceptend
except:
    On Error GoTo finally
    
    MsgBox "Fritz!data ab Version 2.02 Revision 1.26 ist auf diesem PC nicht (korrekt) installiert."
    RaiseAbort
exceptend:
  
  On Error GoTo finally
    
    ' Verfgbare Laufwerke lokal
    AddLogStatus "Ermittle lokal verfgbare Laufwerke..."
    Info = Control.DriveListLocal
    CheckForErrors
    AddLogStatus "Verfgbare Laufwerke: " & Info

    ' lokal in Verzeichnis C:\ wechseln
    AddLogStatus "Wechsle lokal in Verzeichnis C:\..."
    Control.ChDirLocal "C:\"
    WaitUntilReady
    CheckForErrors

    ' Aktuelles lokales Verzeichnis anzeigen
    AddLogStatus "Ermittle aktuelles lokales Verzeichnis"
    Info = Control.CWDLocal
    CheckForErrors
    AddLogStatus "Aktuelles lokales Verzeichnis ist " & Info

    ' Verzeichnisinhalt Desktop
    AddLogStatus "Lese Verzeichnisinhalt von " & Info
    Control.DirLocal
    WaitUntilReady
    CheckForErrors

    PrintDirectoryOutput
     
     ' Verbindung zu AVM Data Call Center aufbauen
    AddLogStatus "Whle Nr. " & PhoneNumber
    Control.Connect PhoneNumber, "", "", FDCO_IDTRANS + FDCO_IDTRANSCOMPRESSION
    WaitUntilReady
    CheckForErrors

    ' Servernamen anzeigen
    AddLogStatus "Verbunden mit " & Control.ServerName

    ' Verfgbare Laufwerke auf Server
    AddLogStatus "Ermittle verfgbare Laufwerke auf Server..."
    Info = Control.DriveListRemote
    CheckForErrors
    AddLogStatus "Verfgbare Laufwerke: " & Info

    ' Lange Dateinamen untersttzt?
    AddLogStatus "Ermittle Verfgbarkeit von langen Dateinamen..."
    BInfo = Control.LFNSupported
    CheckForErrors
    If BInfo Then
      AddLogStatus "Lange Dateinamen werden untersttzt."
    Else
      AddLogStatus "Lange Dateinamen werden nicht untersttzt."
    End If

    ' Aktuelles Verzeichnis auf Server anzeigen
    AddLogStatus "Ermittle aktuelles Verzeichnis auf Server"
    Info = Control.CWDRemote
    CheckForErrors
    AddLogStatus "Aktuelles Verzeichnis auf Server ist " & Info

    ' Verzeichnisinhalt Server Startverzeichnis
    AddLogStatus "Lese Verzeichnisinhalt auf Server..."
    Control.DirRemote
    WaitUntilReady
    CheckForErrors

    PrintDirectoryOutput

    ' Verzeichnis auf Server wechseln
    AddLogStatus "Wechsle in Verzeichnis " & TargetDir
    Control.ChDirRemote TargetDir
    WaitUntilReady
    CheckForErrors

    ' Aktuelles Verzeichnis auf Server anzeigen
    AddLogStatus "Ermittle aktuelles Verzeichnis auf Server"
    Info = Control.CWDRemote
    CheckForErrors
    AddLogStatus "Aktuelles Verzeichnis auf Server ist " & Info

    ' Verzeichnisinhalt Verzeichnis auf Server
    AddLogStatus "Lese Verzeichnisinhalt von " & Info
    Control.DirRemote
    WaitUntilReady
    CheckForErrors

    PrintDirectoryOutput

    ' Datei vom Server auf den Desktop laden
    AddLogStatus "Downloade Datei " & TargetFile & " (Dauert > 1 Min)"
    Control.Download TargetFile, False
    WaitUntilReady
    CheckForErrors

    ' Verbindung beenden
    AddLogStatus "Beende Verbindung..."
    Control.Disconnect
    WaitUntilReady
    CheckForErrors

    AddLogStatus "Fertig!"
    AddLogNewLine
    AddLogNewLine
    
finally:
    Control.FritzDataDisconnect
  
End Sub

''----------------------------------------------------------------------
''  Button "Start"
''  Aktion starten
''----------------------------------------------------------------------
Private Sub cmdStart_Click()
  
  cmdStart.Enabled = False
  cmdCancel.Enabled = True
  DoEvents
  
  On Error GoTo finally
    
  Action
finally:
    cmdStart.Enabled = True
    cmdCancel.Enabled = False
End Sub

''----------------------------------------------------------------------
''  Button "Abbrechen"
''  Gewnschten Abbruch signalisieren
''----------------------------------------------------------------------
Private Sub cmdCancel_Click()
  Aborted = True
End Sub

''----------------------------------------------------------------------
''  Beim Schlieen des Fensters Abbruch signalisieren
''----------------------------------------------------------------------
Private Sub Form_QueryUnload(Cancel As Integer, UnloadMode As Integer)
  If cmdCancel.Enabled Then
    cmdCancel_Click
  End If
End Sub
