unit FritzDataControlLib_TLB;

// ************************************************************************ //
// WARNUNG                                                                    
// -------                                                                    
// Die in dieser Datei deklarierten Typen wurden aus Daten einer Typbibliothek
// generiert. Wenn diese Typbibliothek explizit oder indirekt (ber eine     
// andere Typbibliothek) reimportiert wird oder wenn die Anweisung            
// 'Aktualisieren' im Typbibliotheks-Editor whrend des Bearbeitens der     
// Typbibliothek aktiviert ist, wird der Inhalt dieser Datei neu generiert und 
// alle manuell vorgenommenen nderungen gehen verloren.                           
// ************************************************************************ //

// PASTLWTR : $Revision:   1.130  $
// Datei generiert am 2001-09-09 15:29:22 aus der unten beschriebenen Typbibliothek.

// ************************************************************************  //
// Typbib: F:\Work\ChaoSoft\FritzDataControl\source\FritzDataControlLib.tlb (1)
// LIBID: {FCD95DE5-A307-11D5-95AC-C0BC2F578811}
// LCID: 0
// Hilfedatei: 
// AbhLst: 
//   (1) v2.0 stdole, (C:\WINDOWS\SYSTEM\STDOLE2.TLB)
//   (2) v4.0 StdVCL, (C:\WINDOWS\SYSTEM\STDVCL40.DLL)
// ************************************************************************ //
{$TYPEDADDRESS OFF} // Unit mu ohne Typberprfung fr Zeiger compiliert werden. 

{$IFDEF VER140}
{$WARN SYMBOL_PLATFORM OFF}
{$ENDIF}
{$WRITEABLECONST ON}

interface

uses
  {$IFDEF VER140}
  Variants,
  {$ENDIF}
  ActiveX,
  Classes,
  Graphics,
  StdVCL,
  Windows;
  

// *********************************************************************//
// In dieser Typbibliothek deklarierte GUIDS . Es werden folgende         
// Prfixe verwendet:                                                     
//   Typbibliotheken     : LIBID_xxxx                                     
//   CoClasses           : CLASS_xxxx                                     
//   DISPInterfaces      : DIID_xxxx                                      
//   Nicht-DISP-Schnittstellen: IID_xxxx                                       
// *********************************************************************//
const
  // Haupt- und Nebenversionen der Typbibliothek
  FritzDataControlLibMajorVersion = 1;
  FritzDataControlLibMinorVersion = 0;

  LIBID_FritzDataControlLib: TGUID = '{FCD95DE5-A307-11D5-95AC-C0BC2F578811}';

  IID_IFritzDataControlDocument: TGUID = '{FCD95DE6-A307-11D5-95AC-C0BC2F578811}';
  IID_IFritzDataMessageHandler: TGUID = '{548F9EC6-00EB-11D4-A344-525400EA3749}';
  CLASS_FritzDataControlDocument: TGUID = '{FCD95DE8-A307-11D5-95AC-C0BC2F578811}';

// *********************************************************************//
// Deklaration von in der Typbibliothek definierten Enumerationen         
// *********************************************************************//
// Konstanten fr enum FritzDataControlOptions
type
  FritzDataControlOptions = TOleEnum;
const
  FDCO_IDTRANS = $00000001;
  FDCO_TWOCHANNEL = $00000002;
  FDCO_IDTRANSCOMPRESSION = $00000004;
  FDCO_V42COMPRESSION = $00000008;

// Konstanten fr enum FritzDataFileType
type
  FritzDataFileType = TOleEnum;
const
  FDFT_DIRECTORY = $00000000;
  FDFT_FILE = $00000001;
  FDFT_EOL = $00000002;

// Konstanten fr enum FritzDataErrorCodes
type
  FritzDataErrorCodes = TOleEnum;
const
  FDEC_UNKNOWN = $0000FFFF;
  FDEC_WRONGPARAMETERS = $0000FFFE;
  FDEC_NOTPOSSIBLE = $0000FFFD;
  FDEC_NOTREADY = $0000FFFC;
  FDEC_GENERALFAILURE = $00040000;
  FDEC_FILETRANSFER = $00040001;
  FDEC_FILEACCESS = $0004001E;
  FDEC_PATHNOTFOUND = $0004001F;
  FDEC_ACCESSDENIED = $00040020;
  FDEC_FILEOPEN = $00040021;
  FDEC_TIMEOUT = $00040022;
  FDEC_LOGINFAILURE = $00040023;
  FDEC_FILEALREADYEXISTS = $00040026;
  FDEC_IDLETIMEOUT = $00040027;
  FDEC_DOSERROR = $00040028;
  FDEC_NOREPLY = $00040064;
  FDEC_NODISKSPACE = $00040065;
  FDEC_DISKERROR = $00040066;
  FDEC_DATAEXPECTED = $00040067;
  FDEC_NOACK = $00040068;
  FDEC_INVALIDRECIPIENT = $00040069;
  FDEC_OUTOFMEMORY = $0004006A;
  FDEC_PATHACCESS = $0004006C;
  FDEC_FILENOTFOUND = $0004006D;
  FDEC_CONNCOLLISION = $0004006E;
  FDEC_ABORT = $0004006F;
  FDEC_INCOMPRECIPIENT = $00040070;

type

// *********************************************************************//
// Forward-Deklaration von in der Typbibliothek definierten Typen         
// *********************************************************************//
  IFritzDataControlDocument = interface;
  IFritzDataControlDocumentDisp = dispinterface;
  IFritzDataMessageHandler = interface;
  IFritzDataMessageHandlerDisp = dispinterface;

// *********************************************************************//
// Deklaration von in der Typbibliothek definierten CoClasses             
// (HINWEIS: Hier wird jede CoClass zu ihrer Standardschnittstelle        
// zugewiesen)                                                            
// *********************************************************************//
  FritzDataControlDocument = IFritzDataControlDocument;


// *********************************************************************// 
// Deklaration von  Strukturen, Unions und Aliasen.                        
// *********************************************************************// 
  FritzDataFileInfo = packed record
    Typ: FritzDataFileType;
    FileName: WideString;
    Size: Integer;
    LastChange: TDateTime;
  end;


// *********************************************************************//
// Schnittstelle: IFritzDataControlDocument
// Flags:     (4416) Dual OleAutomation Dispatchable
// GUID:      {FCD95DE6-A307-11D5-95AC-C0BC2F578811}
// *********************************************************************//
  IFritzDataControlDocument = interface(IDispatch)
    ['{FCD95DE6-A307-11D5-95AC-C0BC2F578811}']
    function  FritzDataAlreadyRuns: WordBool; safecall;
    procedure FritzDataConnect; safecall;
    procedure FritzDataDisconnect; safecall;
    function  Get_CWDLocal: WideString; safecall;
    function  Get_LocalReady: WordBool; safecall;
    function  Get_Ready: WordBool; safecall;
    function  Get_Busy: WordBool; safecall;
    procedure DirLocal; safecall;
    function  GetNextDirItem(out FileInfo: FritzDataFileInfo): FritzDataFileType; safecall;
    procedure Connect(const Address: WideString; const UserName: WideString; 
                      const Password: WideString; Options: SYSINT); safecall;
    procedure Disconnect; safecall;
    procedure DirRemote; safecall;
    procedure ChDirLocal(const NewPath: WideString); safecall;
    procedure ChDirRemote(const NewPath: WideString); safecall;
    procedure MkDirLocal(const DirName: WideString); safecall;
    procedure MkDirRemote(const DirName: WideString); safecall;
    procedure DeleteLocal(const FileName: WideString); safecall;
    procedure DeleteRemote(const FileName: WideString); safecall;
    procedure Upload(const FileName: WideString; Move: WordBool); safecall;
    procedure Download(const FileName: WideString; Move: WordBool); safecall;
    procedure Abort; safecall;
    function  Get_CWDRemote: WideString; safecall;
    function  Get_DriveListLocal: WideString; safecall;
    function  Get_DriveListRemote: WideString; safecall;
    function  Get_ServerName: WideString; safecall;
    function  Get_LFNSupported: WordBool; safecall;
    function  Get_ConnStatus: SYSINT; safecall;
    function  GetCAPIISDNErrorMessage(Error: SYSINT): WideString; safecall;
    function  Get_ErrorOccured: WordBool; safecall;
    function  Get_ErrorNr: SYSINT; safecall;
    function  Get_ErrorMessage: WideString; safecall;
    property CWDLocal: WideString read Get_CWDLocal;
    property LocalReady: WordBool read Get_LocalReady;
    property Ready: WordBool read Get_Ready;
    property Busy: WordBool read Get_Busy;
    property CWDRemote: WideString read Get_CWDRemote;
    property DriveListLocal: WideString read Get_DriveListLocal;
    property DriveListRemote: WideString read Get_DriveListRemote;
    property ServerName: WideString read Get_ServerName;
    property LFNSupported: WordBool read Get_LFNSupported;
    property ConnStatus: SYSINT read Get_ConnStatus;
    property ErrorOccured: WordBool read Get_ErrorOccured;
    property ErrorNr: SYSINT read Get_ErrorNr;
    property ErrorMessage: WideString read Get_ErrorMessage;
  end;

// *********************************************************************//
// DispIntf:  IFritzDataControlDocumentDisp
// Flags:     (4416) Dual OleAutomation Dispatchable
// GUID:      {FCD95DE6-A307-11D5-95AC-C0BC2F578811}
// *********************************************************************//
  IFritzDataControlDocumentDisp = dispinterface
    ['{FCD95DE6-A307-11D5-95AC-C0BC2F578811}']
    function  FritzDataAlreadyRuns: WordBool; dispid 1;
    procedure FritzDataConnect; dispid 2;
    procedure FritzDataDisconnect; dispid 3;
    property CWDLocal: WideString readonly dispid 5;
    property LocalReady: WordBool readonly dispid 4;
    property Ready: WordBool readonly dispid 6;
    property Busy: WordBool readonly dispid 7;
    procedure DirLocal; dispid 8;
    function  GetNextDirItem(out FileInfo: {??FritzDataFileInfo}OleVariant): FritzDataFileType; dispid 9;
    procedure Connect(const Address: WideString; const UserName: WideString; 
                      const Password: WideString; Options: SYSINT); dispid 10;
    procedure Disconnect; dispid 11;
    procedure DirRemote; dispid 12;
    procedure ChDirLocal(const NewPath: WideString); dispid 13;
    procedure ChDirRemote(const NewPath: WideString); dispid 14;
    procedure MkDirLocal(const DirName: WideString); dispid 15;
    procedure MkDirRemote(const DirName: WideString); dispid 16;
    procedure DeleteLocal(const FileName: WideString); dispid 17;
    procedure DeleteRemote(const FileName: WideString); dispid 18;
    procedure Upload(const FileName: WideString; Move: WordBool); dispid 19;
    procedure Download(const FileName: WideString; Move: WordBool); dispid 20;
    procedure Abort; dispid 21;
    property CWDRemote: WideString readonly dispid 22;
    property DriveListLocal: WideString readonly dispid 23;
    property DriveListRemote: WideString readonly dispid 24;
    property ServerName: WideString readonly dispid 25;
    property LFNSupported: WordBool readonly dispid 26;
    property ConnStatus: SYSINT readonly dispid 27;
    function  GetCAPIISDNErrorMessage(Error: SYSINT): WideString; dispid 28;
    property ErrorOccured: WordBool readonly dispid 29;
    property ErrorNr: SYSINT readonly dispid 30;
    property ErrorMessage: WideString readonly dispid 31;
  end;

// *********************************************************************//
// Schnittstelle: IFritzDataMessageHandler
// Flags:     (4432) Hidden Dual OleAutomation Dispatchable
// GUID:      {548F9EC6-00EB-11D4-A344-525400EA3749}
// *********************************************************************//
  IFritzDataMessageHandler = interface(IDispatch)
    ['{548F9EC6-00EB-11D4-A344-525400EA3749}']
    procedure PutMessage(Message: Smallint; LParam: Integer; VParam: OleVariant; 
                         var pResult: Integer); safecall;
  end;

// *********************************************************************//
// DispIntf:  IFritzDataMessageHandlerDisp
// Flags:     (4432) Hidden Dual OleAutomation Dispatchable
// GUID:      {548F9EC6-00EB-11D4-A344-525400EA3749}
// *********************************************************************//
  IFritzDataMessageHandlerDisp = dispinterface
    ['{548F9EC6-00EB-11D4-A344-525400EA3749}']
    procedure PutMessage(Message: Smallint; LParam: Integer; VParam: OleVariant; 
                         var pResult: Integer); dispid 1;
  end;

// *********************************************************************//
// Die Klasse CoFritzDataControlDocument stellt die Methoden Create und CreateRemote zur      
// Verfgung, um Instanzen der Standardschnittstelle IFritzDataControlDocument, dargestellt von
// CoClass FritzDataControlDocument, zu erzeugen. Diese Funktionen knnen                     
// von einem Client verwendet werden, der die CoClasses automatisieren    
// mchte, die von dieser Typbibliothek dargestellt werden.               
// *********************************************************************//
  CoFritzDataControlDocument = class
    class function Create: IFritzDataControlDocument;
    class function CreateRemote(const MachineName: string): IFritzDataControlDocument;
  end;

implementation

uses ComObj;

class function CoFritzDataControlDocument.Create: IFritzDataControlDocument;
begin
  Result := CreateComObject(CLASS_FritzDataControlDocument) as IFritzDataControlDocument;
end;

class function CoFritzDataControlDocument.CreateRemote(const MachineName: string): IFritzDataControlDocument;
begin
  Result := CreateRemoteComObject(MachineName, CLASS_FritzDataControlDocument) as IFritzDataControlDocument;
end;

end.
